<?php
  
  /* Define the HMAC KEY */
  $hmac_key = "01020304050607080910111213141516";
  
  /* Use Predis to use Redis */
  require "predis-1.1/autoload.php";
  Predis\Autoloader::register();
  try 
  {
    $redis = new Predis\Client();
  }
  catch (Exception $e) 
  {
    die($e->getMessage());
  }

  if (isset($_POST['what']))
  {
    /* This is a post  */

    /* Write the request in output file */
    /* -------------------------------- */
    if (!file_exists('output'))
      mkdir('output', 0777, true);    

    if (!file_exists('output/rcvd.csv'))
    {
      $fp = fopen("output/rcvd.csv", 'a');
      $firt_line = "when;what;sequence;counter;mac;tampers;id;info;auth\r\n";
      fwrite($fp, $firt_line); 
    } else
    {
      $fp = fopen("output/rcvd.csv", 'a');     
    }
    date_default_timezone_set('Europe/Paris');
    $rcvd  = date("Y-m-d H:i:s") . ";"; 
    $rcvd .= $_POST['what'] . ";";
    $rcvd .= $_POST['sequence'] . ";";
    $rcvd .= $_POST['counter'] . ";";
    $rcvd .= $_POST['mac'] . ";";
    $rcvd .= $_POST['tampers'] . ";";
    if (isset($_POST['id']))
    {
      $rcvd .= $_POST['id'] . ";";
    } else
    {
      $rcvd .= ";";
    }   
    if (isset($_POST['info']))
    {
      $rcvd .= $_POST['info'] . ";";
    } else
    {
      $rcvd .= ";";
    }
    
    $rcvd .= $_POST['auth'] . "\r\n";
    fwrite($fp, $rcvd);
    fclose($fp);

    
    /* Check authentication */
    /* -------------------- */  
    $rawdata = file_get_contents('php://input');
    $elts = explode("&", $rawdata);
    $payload = '';
    $first = true;
    
    foreach ($elts as $elt)
    {
      if (strpos($elt, 'auth') === false)
      {
        if ($first)
        {
          $payload .= $elt;
          $first = false;
        } else
        {
          $payload .= '&' . $elt;
        }
      }
    }

    $sig = hash_hmac( 'md5', $payload, pack("H*", $hmac_key), false);
    
    
    if ('"' . strtolower($sig) . '"'  != strtolower($_POST['auth']))
    {
      /* Authentication is incorrect --> throw a 403 error */
      header($_SERVER["SERVER_PROTOCOL"]." 403 Forbidden", true, 403);
      return;
    }
      
    /* Construct a JSON object and add it in Redis */
    /* ------------------------------------------- */
    
    /* Brackets "" are added for mac, tampers and id, for the JQUERY JSON parser */
    $json_rcvd = '{';
    $json_rcvd .= '"ip": "' . $_SERVER['REMOTE_ADDR'] . '"';
    $json_rcvd .= ', "when": "' . date("Y-m-d H:i:s") . '"';
    $json_rcvd .= ', "what": ' . $_POST['what'];
    $json_rcvd .= ', "sequence": ' . $_POST['sequence'];
    $json_rcvd .= ', "counter": ' . $_POST['counter'];
    $json_rcvd .= ', "mac": "' . $_POST['mac'] . '"';
    $json_rcvd .= ', "tampers": "' . $_POST['tampers'] . '"';
    if (isset($_POST['info']))
      $json_rcvd .= ', "info": ' . $_POST['info'];
    if (isset($_POST['id']))
      $json_rcvd .= ', "id": "' . $_POST['id'] . '"';
    $json_rcvd .= '}';

    $redis->lpush("rcvd", $json_rcvd);
    $redis->ltrim("rcvd", 0, 9);
    
    /* Prepare and send the answer */
    /* --------------------------- */
    $resp;
    if (($_POST['what'] == '"read"') || $_POST['what'] == '"insert"')
    {
      /* A badge is read or inserted: perform access control */
      $resp = "{";
      $resp .= "\"led-red\": ";
      $resp .= "\"off\", ";
      
      $resp .= "\"led-green\": ";
      $resp .= "\"blink-fast\", ";    
      
      $resp .= "\"led-time\": ";
      $resp .= "6, ";       
      
      $resp .= "\"buzz\": ";
      $resp .= "3";     
          
      $resp .= "}"; 
      
    } else
    {
      /* Nothing is read, this must be a startup, keep alive, or badge removed */
      $resp = "{";
      $resp .= "\"led-red\": ";
      $resp .= "\"blink-slow\", ";
      
      $resp .= "\"led-green\": ";
      $resp .= "\"off\", ";    
      
      $resp .= "\"led-time\": ";
      $resp .= "4, ";       
      
      $resp .= "\"buzz\": ";
      $resp .= "0";     
          
      $resp .= "}";    
    } 
    
    /*
    $rawdata = file_get_contents('php://input');
    $elts = explode("&", $rawdata);
    $payload = '';
    $first = true;
    
    foreach ($elts as $elt)
    {
      if (strpos($elt, 'auth') === false)
      {
        if ($first)
        {
          $payload .= $elt;
          $first = false;
        } else
        {
          $payload .= '&' . $elt;
        }
      }
    }
    
    echo $payload;
    */
    echo $resp;

  }

?>
